
#include "usart.h"
#include "debug.h"

u8 USART_Rbuffer_Num = 0;
u8 USART_Tbuffer_Num = 0;
u8 USART_Rbuffer[buffer_len];//ջ

void USARTx_Init(void)
{
    GPIO_InitTypeDef   GPIO_InitStructure={0};
    USART_InitTypeDef  USART_InitStructure={0};
    NVIC_InitTypeDef   NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_AFIO,ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3,ENABLE);

    GPIO_PinRemapConfig(GPIO_PartialRemap_USART3, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(USART3, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;           //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(USART3,USART_IT_RXNE,ENABLE);
    USART_ITConfig(USART3,USART_IT_IDLE,ENABLE);

    USART_Cmd(USART3,ENABLE);
}

void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{
    USART_SendData(pUSARTx, data);
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

void USARTx_SendStr(USART_TypeDef* pUSARTx, char *str)
{
    uint8_t i = 0;
    do
    {
       USARTx_SendByte(pUSARTx, *(str+i));
       i++;
    }while(*(str+i) != '\0');
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TC) == RESET);
}

void USART3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void USART3_IRQHandler(void)
{
    if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET) //жϲ
    {
        USART_ClearITPendingBit(USART3,USART_IT_RXNE);                //жϱ־
        USART_Rbuffer[USART_Rbuffer_Num] = USART_ReceiveData(USART3); //
        USART_Rbuffer_Num++;
    }

    if(USART_GetITStatus(USART3, USART_IT_IDLE) != RESET) //жϲ
    {
//        USARTx_SendStr(USART3, "\r\nThis is a idle status.\r\n");
        Delay_Ms(500);
        USART_ReceiveData(USART3);                //DR
    }

    for(USART_Tbuffer_Num=0;USART_Tbuffer_Num < USART_Rbuffer_Num;USART_Tbuffer_Num++)
    {
        USARTx_SendByte(USART3,USART_Rbuffer[USART_Tbuffer_Num]); //
    }

    USART_Rbuffer_Num = 0; //ʼ
    USART_Tbuffer_Num = 0;
}


